/*
 *  of1394VideoGrabber.h
 *  openFrameworks
 *
 *  Created by Zach Gage on 8/8/08.
 *  Copyright 2008 stfj. All rights reserved.
 *
 */
#ifndef _OF_1394_VIDEO_GRABBER
#define _OF_1394_VIDEO_GRABBER

#include "ofConstants.h"
#include "ofTexture.h"
#include "ofGraphics.h"
#include <iostream>

#include <dc1394/dc1394.h>
//#include <dc1394/vendor/avt.h>


class of1394VideoGrabber{
	
	public :
	
	of1394VideoGrabber();
	~of1394VideoGrabber();
	
	void 			listDevices();
	bool 			isFrameNew();
	void			grabFrame();
	void 			initGrabber();
//	void			initGrabber(int w, int h, bool bTexture);
	void			videoSettings();
	unsigned char 	* getPixels();
	void 			setVerbose(bool bTalkToMe);
	void			setDeviceID(int _deviceID);
	void 			setUseTexture(bool bUse);
	void 			draw(float x, float y, float w, float h);
	void 			draw(float x, float y);
	//int 			width, height;
	ofTexture 				tex;
	
	dc1394camera_t *camera;
    int i;
    dc1394featureset_t features;
    dc1394framerates_t framerates;
    dc1394video_modes_t video_modes;
    dc1394framerate_t framerate;
    dc1394video_mode_t video_mode;
    dc1394color_coding_t coding;
    unsigned int width, height;
    dc1394video_frame_t *frame;
	dc1394video_frame_t *deBayeredFrame;
    dc1394_t * d;
    dc1394camera_list_t * list;
	
	dc1394error_t err;
	
protected:
	
	bool					bChooseDevice;
	int						deviceID;
	bool					bUseTexture;
	bool 					bVerbose;
	bool 					bGrabberInited;
	unsigned char * 		pixels;
	bool 					bIsFrameNew;
	
	
};




#endif

